Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Motion Class Reference

A process for actorics. More...

`#include <Motion.h>`

Inheritance diagram for Motion:

[legend]
Collaboration diagram for Motion:

[legend]
List of all members.

## Public Member Functions
| Motion ()
| ~Motion ()
virtual int | main ()
| is called from the framework once in every frame
virtual void | init ()
| is called direct before the first call of main()
virtual bool | handleMessage (InMessage &message)
| The function handles incoming debug messages.
## Protected Attributes
unsigned int | motionControlExecuteSlowMotion
double | gameSpeed
| Can be used to slow down the game for debugging purposes (slow motion).
bool | headIsBlockedBySpecialActionOrWalk
| Specifies if the head is blocked by a special action or walk.
bool | traceStored
| Has a trace already been stored?
bool | replace
Pose2D | walkParams
modules
SensorDataProcessorSelector * | pSensorDataProcessor
| a reference to the sensor data processor
HeadControlSelector * | pHeadControl
| a pointer to the HeadControl module
LEDControlSelector * | pLEDControl
| a pointer to the LEDControl module
MotionControlSelector * | pMotionControl
| a pointer to the MotionControl module
SoundControlSelector * | pSoundControl
| a pointer to the SoundControl module
representations
HeadMotionRequest | headMotionRequest
| the head motion request
CameraMatrix | cameraMatrix
| The position and rotation of the camera relative to the robot.
PSDPercept | psdPercept
| The psd percept calculated by the sensor data processor.
BodyPercept | bodyPercept
| The body percept calculated by the sensor data processor.
BodyPosture | bodyPosture
| The height and the inclination of the robot's body.
OdometryData | lastOdometry
| The odometry which was calculated in the before last frame.
ObstaclesModel | obstaclesModel
| obstacles model from cognition
unsigned long | lastFrameRobotPoseWasUpdated
| Frame number in which robot pose was last updated.
RingBuffer< OdometryData, 40 > | odometryHistory
| Used to update robot pose.
## Private Member Functions
| RECEIVER (SensorDataBuffer)
| RECEIVER (PackageCognitionMotion)
| SHARED_SENDER (Trace)
| SHARED_RECEIVER (Trace)
| SENDER (PackageMotionCognition)
| SENDER (OdometryData)
## Private Attributes
| DEBUGGING
| SENDER_MOTORCOMMANDS
| SENDER_SOUNDDATA

## Detailed Description

A process for actorics.

Definition at line 28 of file Motion.h.

## Constructor & Destructor Documentation

Motion::Motion | ( |  | ) |

| Definition at line 16 of file Motion.cpp. References Process::debugOut, INIT_DEBUGGING, INIT_RECEIVER, INIT_RECEIVER_SENSORDATA, INIT_SENDER, INIT_SENDER_MOTORCOMMANDS, INIT_SENDER_SOUNDDATA, pHeadControl, pLEDControl, pMotionControl, pSoundControl, replace, MessageQueue::setSize(), and setTrace().

Here is the call graph for this function:

Motion::~Motion | ( |  | ) |

| Definition at line 108 of file Motion.cpp. References pHeadControl, pLEDControl, pMotionControl, and pSoundControl.

## Member Function Documentation

Motion::RECEIVER | ( | SensorDataBuffer |  | ) | `[private]`

Motion::RECEIVER | ( | PackageCognitionMotion |  | ) | `[private]`

Motion::SHARED_SENDER | ( | Trace |  | ) | `[private]`

Motion::SHARED_RECEIVER | ( | Trace |  | ) | `[private]`

Motion::SENDER | ( | PackageMotionCognition |  | ) | `[private]`

Motion::SENDER | ( | OdometryData |  | ) | `[private]`

int Motion::main | ( |  | ) | `[virtual]`

| is called from the framework once in every frame Implements Process. Definition at line 124 of file Motion.cpp. References DEBUG_RESPONSE, ModuleSelector::execute(), idJointData, idSensorData, idText, INFO, and OUTPUT.

Here is the call graph for this function:

void Motion::init | ( |  | ) | `[virtual]`

| is called direct before the first call of main() Reimplemented from Process. Definition at line 117 of file Motion.cpp.

bool Motion::handleMessage | ( | InMessage & | message | ) | `[virtual]`

  | The function handles incoming debug messages. Parameters:
  message | the message to handle
Returns: Has the message been handled? Reimplemented from Process. Definition at line 280 of file Motion.cpp. References InMessage::bin, Process::debugDataTable, gameSpeed, InMessage::getMessageID(), getRobotConfiguration(), Process::handleMessage(), ModuleSelector::handleMessage(), RobotConfiguration::handleMessage(), idBodyOffsets, idDebugDataChangeRequest, idGameSpeed, idGT2005Request, idHeadMotionRequest, idMotionControlSlowMotion, idOdometryData, idOdometryScale, idPIDData, idXabsl2DebugRequest, motionControlExecuteSlowMotion, pHeadControl, pMotionControl, and DebugDataTable::processChangeRequest().

Here is the call graph for this function:

## Member Data Documentation

Motion::DEBUGGING`[private]`

| Definition at line 31 of file Motion.h.

Motion::SENDER_MOTORCOMMANDS`[private]`

| Definition at line 37 of file Motion.h.

Motion::SENDER_SOUNDDATA`[private]`

| Definition at line 38 of file Motion.h.

SensorDataProcessorSelector* Motion::pSensorDataProcessor`[protected]`

| a reference to the sensor data processor Definition at line 65 of file Motion.h.

HeadControlSelector* Motion::pHeadControl`[protected]`

| a pointer to the HeadControl module Definition at line 68 of file Motion.h. Referenced by handleMessage(), Motion(), and ~Motion().

LEDControlSelector* Motion::pLEDControl`[protected]`

| a pointer to the LEDControl module Definition at line 71 of file Motion.h. Referenced by Motion(), and ~Motion().

MotionControlSelector* Motion::pMotionControl`[protected]`

| a pointer to the MotionControl module Definition at line 74 of file Motion.h. Referenced by handleMessage(), Motion(), and ~Motion().

SoundControlSelector* Motion::pSoundControl`[protected]`

| a pointer to the SoundControl module Definition at line 77 of file Motion.h. Referenced by Motion(), and ~Motion().

unsigned int Motion::motionControlExecuteSlowMotion`[protected]`

| Definition at line 80 of file Motion.h. Referenced by handleMessage().

HeadMotionRequest Motion::headMotionRequest`[protected]`

| the head motion request Definition at line 86 of file Motion.h.

CameraMatrix Motion::cameraMatrix`[protected]`

| The position and rotation of the camera relative to the robot. Definition at line 89 of file Motion.h.

PSDPercept Motion::psdPercept`[protected]`

| The psd percept calculated by the sensor data processor. Definition at line 92 of file Motion.h.

BodyPercept Motion::bodyPercept`[protected]`

| The body percept calculated by the sensor data processor. Definition at line 95 of file Motion.h.

BodyPosture Motion::bodyPosture`[protected]`

| The height and the inclination of the robot's body. Definition at line 98 of file Motion.h.

OdometryData Motion::lastOdometry`[protected]`

| The odometry which was calculated in the before last frame. Definition at line 101 of file Motion.h.

ObstaclesModel Motion::obstaclesModel`[protected]`

| obstacles model from cognition Definition at line 104 of file Motion.h.

unsigned long Motion::lastFrameRobotPoseWasUpdated`[protected]`

| Frame number in which robot pose was last updated. Definition at line 107 of file Motion.h.

RingBuffer<OdometryData,40> Motion::odometryHistory`[protected]`

| Used to update robot pose. Definition at line 110 of file Motion.h.

double Motion::gameSpeed`[protected]`

| Can be used to slow down the game for debugging purposes (slow motion). Is multiplied to the incoming MotionRequest and to the outgoing executedMotionRequest. 1: Normal speed -- 0.1: almost dont move Definition at line 118 of file Motion.h. Referenced by handleMessage().

bool Motion::headIsBlockedBySpecialActionOrWalk`[protected]`

| Specifies if the head is blocked by a special action or walk. Definition at line 121 of file Motion.h.

bool Motion::traceStored`[protected]`

| Has a trace already been stored? Definition at line 124 of file Motion.h.

bool Motion::replace`[protected]`

| Definition at line 126 of file Motion.h. Referenced by Motion().

Pose2D Motion::walkParams`[protected]`

| Definition at line 127 of file Motion.h.

The documentation for this class was generated from the following files:

- Processes/CMD/Motion.h
- Processes/CMD/Motion.cpp